import net.arikia.dev.drpc.callbacks.*;
import net.arikia.dev.drpc.DiscordRPC;
import net.arikia.dev.drpc.DiscordRichPresence;
import net.arikia.dev.drpc.DiscordEventHandlers;
import processing.opengl.*;
import java.io.FilenameFilter;
import ddf.minim.*;


AudioPlayer toPlay;
Minim minim;
DisposeHandler dh;
musicInfo infos;
settingsMenu settings;
SettingsJSON settingsFile;
BalanceGD balance;
boolean inSettsMenu = false;
String[] filenames;
String fullPath;
int wichIsPlaying;
boolean isPaused;
float tempsChanson = 0;
int fps = 30;
int offsets = 0;
PImage iconeParams;
PImage iconeDossier;
boolean isCharged = false;
StringList nomChanson;
Boolean pathIsExisting = true;
Boolean askedOnce = false;
int previousHeight;
int alphaBoutonPause = 127;
int alphaBoutonRetour = 127;
int alphaBoutonSkip = 127;
DiscordRPC rpc;
DiscordEventHandlers handlers;
boolean block = true;
int[] coulBC1;
int[] coulBC2;
int[] coulBCInter;

void setup() {

  size(1300, 813, P3D);
  smooth(1);
  handlers = new DiscordEventHandlers.Builder().setReadyEventHandler((user) -> {
    println("Welcome " + user.username + "#" + user.discriminator + "!");
  }
  ).build();
  DiscordRPC.discordInitialize("1066420176775545054", handlers, true);

  DiscordRichPresence rich = new DiscordRichPresence.Builder("IDLING").setBigImage("logo", "logo").build();
  DiscordRPC.discordUpdatePresence(rich);
  settings = new settingsMenu();
  settingsFile = new SettingsJSON();
  infos = new musicInfo();
  balance = new BalanceGD();
  infos.init();
  settings.init();
  settingsFile.verifyIfFileExist();
  settingsFile.initSetts();
  surface.setResizable(true);
  if (!System.getProperty("os.name").contains("Windows")) {
    dh = new DisposeHandler(this);
    //surface.setResizable(true);
    int[] tailles = new int[2];
    tailles = settingsFile.loadSizeWindows();
    surface.setSize(tailles[0], tailles[1]);
    previousHeight = height;
  }
  surface.setIcon(loadImage("data/logo.png"));
  PJOGL.setIcon("data/logo.png");
  fullPath = settingsFile.loadFolder();
  if (fullPath == null) {
    fullPath = "";
    pathIsExisting = false;
  }
  if (fullPath.length() == 0 || fullPath == "") {
    pathIsExisting = false;
  }
  iconeParams = loadImage("data/iconparams2.png");
  iconeDossier = loadImage("data/folderbis.png");
  frameRate(fps);
  degradeInit();
  minim = new Minim(this);
  if (pathIsExisting) {
    refreshList();
  }
}

void draw() {
  if (!System.getProperty("os.name").contains("Windows")) {
    int pwidth = width;
    int pheight = height;
    pwidth = constrain(pwidth, 800, width);
    pheight = constrain(pheight, 800, height);
    //println(previousHeight != height);
    if (previousHeight != height) {
      changeOffstses( - height, true);
    }
    surface.setSize(pwidth, pheight);
  }
  //background(12,81,255);
  degrade(/*0, 0, width, height, color(12,81,255), color(1,10,22), X_AXIS*/);
  if (settingsFile.getMode()) {
    fill(38, 38, 38, 150);
  } else {
    fill(255, 255, 255, 150);
  }
  rect(0, height - 100, width, 100);
  if (!pathIsExisting) {
    if (!askedOnce) {
      isCharged = false;
      selectFolder("Choisissez un dossier pour charger les musiques:", "folderInit");
      askedOnce = true;
    } else {
      textSize(70);
      text("Veuillez choisir un dossier\ncontenant les musiques pour continuer.\nAppuyez sur l'icone de dossier en bas\nà droite de la fenêtre", 0, height / 3);
    }
  } else {
    if (filenames.length!= 0 && isCharged) {
      int canGoOff = 0;
      //println(width, height);
      int y = 0 + offsets;
      textSize(40);
      strokeWeight(1);
      stroke(0);
      for (int i = 0; i <  filenames.length; i++) {
        canGoOff= 0;
        if (settingsFile.getMode()) {
          fill(38, 38, 38, 150);
        } else {
          fill(255, 255, 255, 150);
        }
        if (y + 100 < height - 100) {
          rect(0, y, width / 2, 100, 28);
        } else {
          while (canGoOff + y < height - 100) {
            canGoOff++;
          }
          //println(canGoOff);
          if (canGoOff == 100) {
            rect(0, y, width / 2, 100, 28);
          } else if (canGoOff != 0) {
            rect(0, y, width / 2, canGoOff, 28, 28, 0, 0);
          }
        }
        if (settingsFile.getMode()) {
          fill(255);
        } else {
          fill(0);
        }
        //text(filenames[i].getMetaData().title(), 10,y+50);
        //println(canGoOff == 100 && textWidth(filenames[i].substring( 0, filenames[i].length()-4 )) > width/2, canGoOff);
        if (nomChanson.get(i) != "") {
          text(nomChanson.get(i), 10, y + 50);
        } else {
          if (textWidth(filenames[i].substring(0, filenames[i].length() - 4)) > width / 2 && canGoOff != 100) {
            textLeading(textAscent() + textDescent());
            if (y + (textAscent() + textDescent()) * 2 < height - 100) {
              text(filenames[i].substring(0, filenames[i].length() - 4).substring(0, filenames[i].substring(0, filenames[i].length() - 4).length() / 2) + "\n" +
                filenames[i].substring(0, filenames[i].length() - 4).substring(filenames[i].substring(0, filenames[i].length() - 4).length() / 2, filenames[i].substring(0, filenames[i].length() - 4).length()), 10, y + 40);
            } else if (y+ (textAscent() + textDescent()) < height - 100) {
              text(filenames[i].substring(0, filenames[i].length() - 4).substring(0, filenames[i].substring(0, filenames[i].length() - 4).length() / 2), 10, y + 40);
            }
          } else if (canGoOff == 100 && textWidth(filenames[i].substring(0, filenames[i].length() - 4)) > width / 2) {
            text(filenames[i].substring(0, filenames[i].length() - 4).substring(0, filenames[i].substring(0, filenames[i].length() - 4).length() / 2) + "\n" +
              filenames[i].substring(0, filenames[i].length() - 4).substring(filenames[i].substring(0, filenames[i].length() - 4).length() / 2, filenames[i].substring(0, filenames[i].length() - 4).length()), 10, y + 40);
          } else {
            if (y + (textAscent() + textDescent()) < height - 100) {
              text(filenames[i].substring(0, filenames[i].length() - 4), 10, y + 60);
            }
          }
        }
        y += 100;
      }

      if (toPlay.isPlaying() || isPaused) {
        tempsChanson = toPlay.position() / 1000.0;
        textSize(25);
        textAlign(CENTER);
        if (nomChanson.get(wichIsPlaying) != "") {
          text(nomChanson.get(wichIsPlaying), width / 2, height - 75);
        } else {
          text(filenames[wichIsPlaying].substring(0, filenames[wichIsPlaying].length() - 4), width / 2, height - 75);
        }
        infos.promptInfo();
        balance.draw();
      }
      textAlign(LEFT);

      if (settingsFile.getMode()) {
        fill(255);
      } else {
        fill(0);
      }
      String timer = "";
      if (toPlay.length() / 1000 % 60 < 10) {
        if (int(tempsChanson % 60) < 10) {
          timer = str(int(tempsChanson / 60)) + ":0" + str(int(tempsChanson % 60)) + " / " + str(toPlay.length() / 1000 / 60) + ":0" + str(toPlay.length() / 1000 % 60);
        } else {
          timer = str(int(tempsChanson / 60)) + ":" + str(int(tempsChanson % 60)) + " / " + str(toPlay.length() / 1000 / 60) + ":0" + str(toPlay.length() / 1000 % 60);
        }
      } else {
        if (int(tempsChanson % 60) < 10) {
          timer = str(int(tempsChanson / 60)) + ":0" + str(int(tempsChanson % 60)) + " / " + str(toPlay.length() / 1000 / 60) + ":" + str(toPlay.length() / 1000 % 60);
        } else {
          timer = str(int(tempsChanson / 60)) + ":" + str(int(tempsChanson % 60)) + " / " + str(toPlay.length() / 1000 / 60) + ":" + str(toPlay.length() / 1000 % 60);
        }
      }
      textSize(40);
      //println(toPlay.isPlaying());
      text(timer, 10, height - 65);
      if (isPaused) {
        if (nomChanson.get(wichIsPlaying) != "") {
          DiscordRichPresence rich = new DiscordRichPresence.Builder("Playing: " + nomChanson.get(wichIsPlaying)).setDetails(timer).setBigImage("logo", "logo").setSmallImage("playlogo", "play").build();
          DiscordRPC.discordUpdatePresence(rich); //playlogo
        } else {
          DiscordRichPresence rich = new DiscordRichPresence.Builder("Playing: " + filenames[wichIsPlaying].substring(0, filenames[wichIsPlaying].length() - 4)).setDetails(timer).setBigImage("logo", "logo").setSmallImage("playlogo", "play").build();
          DiscordRPC.discordUpdatePresence(rich);
        }
      } else {
        if (nomChanson.get(wichIsPlaying) != "") {
          DiscordRichPresence rich = new DiscordRichPresence.Builder("Playing: " + nomChanson.get(wichIsPlaying)).setDetails(timer).setBigImage("logo", "logo").setSmallImage("pauselogo", "pause").build();
          DiscordRPC.discordUpdatePresence(rich); //pauselogo
        } else {
          DiscordRichPresence rich = new DiscordRichPresence.Builder("Playing: " + filenames[wichIsPlaying].substring(0, filenames[wichIsPlaying].length() - 4)).setDetails(timer).setBigImage("logo", "logo").setSmallImage("pauselogo", "pause").build();
          DiscordRPC.discordUpdatePresence(rich);
        }
      }
      fill(255, 255, 255, 127);
      rect(10, height - 50, 200, 5);
      fill(255, 0, 0, 255);
      rect(10, height - 50, 200 * (tempsChanson / (toPlay.length() / 1000.0)), 5);
      ellipseMode(CORNER);

      fill(255, 255, 255, 255);
      ellipse(200 * (tempsChanson / (toPlay.length() / 1000.0)) + 5, height - 55, 15, 15);
      //println(tempsChanson, toPlay.length()/1000.0, tempsChanson / (toPlay.length()/1000.0));
      //if (tempsChanson / (toPlay.length() / 1000.0) > 0.991 ) {
      if (!isPaused && !toPlay.isPlaying() && !block) {
        wichIsPlaying++;
        changeMusique();
      }

      //inSettsMenu = settingsMenu.getRemoveMenu();*/
    } else {
      //println(width, height);
      textSize(width / 10);
      text("Pas de chansons\ndisponible dans\nce répertoire", 0, height / 7);
      triangle(width / 2 - 20, height - 50, width / 2 - 20, height - 25, width / 2 + 10, height - 37.5);

      triangle(width / 2 - 100, height - 50, width / 2 - 100, height - 25, width / 2 - 120, height - 37.5);
      triangle(width / 2 - 20 + 100, height - 50, width / 2 - 20 + 100, height - 25, width / 2 + 100, height - 37.5);
      textSize(40);
      //println("minutes: ", int(tempsChanson/60), "secondes: ", int(tempsChanson%60));
      fill(0);
      text("00:00 / 0:00", 10, height - 65);
      fill(255, 255, 255, 127);
      rect(10, height - 50, 200, 5);
      fill(255, 255, 255, 255);
      rect(10, height - 50, 0, 5);
      ellipseMode(CORNER);
      ellipse(7.5, height - 52.5, 10, 10);
    }
    if (height - 100 > (filenames.length - 1) * 100 + 100) {
      offsets = 0;
    }
  }

  fill(255, 255, 255, alphaBoutonPause);
  //ellipse(width / 2 - 30, height - 62.5, 50, 50);
  rect(width / 2 - 30, height - 62.5, 50, 50, 20);
  fill(255, 255, 255, alphaBoutonSkip);
  rect(width / 2 + 65, height - 62.5, 50, 50, 20);
  fill(255, 255, 255, alphaBoutonRetour);
  rect(width / 2 - 130, height - 62.5, 50, 50, 20);

  if (mouseX > width/2-30 && mouseX < width/2-30+50 && mouseY > height - 62.5 && mouseY < height - 62.5 + 50) {
    alphaBoutonPause+=2;
  } else {
    alphaBoutonPause-=2;
  }
  if (mouseX > width/2+65 && mouseX < width/2+65+50 && mouseY > height - 62.5 && mouseY < height - 62.5 + 50) {
    alphaBoutonSkip+=2;
  } else {
    alphaBoutonSkip-=2;
  }
  if (mouseX > width/2-130 && mouseX < width/2-130+50 && mouseY > height - 62.5 && mouseY < height - 62.5 + 50) {
    alphaBoutonRetour+=2;
  } else {
    alphaBoutonRetour-=2;
  }

  if (alphaBoutonPause >= 255) {
    alphaBoutonPause = 255;
  } else if (alphaBoutonPause <= 127) {
    alphaBoutonPause = 127;
  }

  if (alphaBoutonRetour >= 255) {
    alphaBoutonRetour = 255;
  } else if (alphaBoutonRetour <= 127) {
    alphaBoutonRetour = 127;
  }

  if (alphaBoutonSkip >= 255) {
    alphaBoutonSkip = 255;
  } else if (alphaBoutonSkip <= 127) {
    alphaBoutonSkip = 127;
  }


  //rect(width/2-25, height-57.25, 40, 40);
  //rect(width/2+70, height-57.25, 40, 40);
  //rect(width/2-130, height-57.25, 40, 40);
  fill(0, 0, 0, 255);
  if (pathIsExisting && filenames.length!= 0 && isCharged) {
    if (!isPaused && toPlay.isPlaying()) {
      rect(width / 2 - 20, height - 50, 10, 25);
      rect(width / 2, height - 50, 10, 25);
    } else {
      triangle(width / 2 - 20, height - 50, width / 2 - 20, height - 25, width / 2 + 10, height - 37.5);
    }
  } else {
    triangle(width / 2 - 20, height - 50, width / 2 - 20, height - 25, width / 2 + 10, height - 37.5);
  }
  triangle(width / 2 - 105, height - 50, width / 2 - 105, height - 25, width / 2 - 125, height - 37.5);
  triangle(width / 2 - 105+15, height - 50, width / 2 - 105+15, height - 25, width / 2 - 125+15, height - 37.5);
  triangle(width / 2 - 20 + 95, height - 50, width / 2 - 20 + 95, height - 25, width / 2 + 95, height - 37.5);
  triangle(width / 2 - 20 + 110, height - 50, width / 2 - 20 + 110, height - 25, width / 2 + 110, height - 37.5);
  imageMode(CENTER);
  rectMode(CENTER);
  fill(0, 0, 0, 0);
  rect(width - 50, height - 50, 100, 100, 10, 0, 0, 10);
  image(iconeParams, width - 50, height - 50);
  rectMode(CORNER);
  if (inSettsMenu) {
    settings.settings();
  }
  if (!System.getProperty("os.name").contains("Windows")) {
    previousHeight = height;
  }
}

void mousePressed() {
  if (isCharged) {
    if (!inSettsMenu && filenames.length!= 0) {
      if (mouseX > width/2+65 && mouseX < width/2+65+50 && mouseY > height - 62.5 && mouseY < height - 62.5 + 50) { //  rect(width / 2 + 65, height - 62.5, 50, 50, 20);
        wichIsPlaying++;
        changeMusique();
      } else if (mouseX > width/2-130 && mouseX < width/2-130+50 && mouseY > height - 62.5 && mouseY < height - 62.5 + 50) {  // rect(width / 2 - 130, height - 62.5, 50, 50, 20);
        if ((tempsChanson / (toPlay.length() / 1000.0)) * 100 > 2) {
          toPlay.rewind();
          tempsChanson = 0;
        } else {
          wichIsPlaying--;
          changeMusique();
        }
      } else if (mouseX > width/2-30 && mouseX < width/2-30+50 && mouseY > height - 62.5 && mouseY < height - 62.5 + 50) {   //rect(width / 2 - 30, height - 62.5, 50, 50,20);
        if (block) {
          block = false;
          changeMusique();
        } else {
          if (!isPaused) {
            toPlay.pause();
            isPaused = true;
          } else {
            toPlay.play();
            isPaused = false;
          }
        }
      } else if (mouseY < height - 100 && mouseX < width/2) {
        for (int i = 0; i <  filenames.length; i++) {
          if (mouseY> (i * 100 + offsets) && mouseY < (i * 100 + 100 + offsets) && wichIsPlaying != i) {
            if (toPlay.isPlaying()) {
              toPlay.close();
            }
            tempsChanson= 0;
            toPlay = minim.loadFile(fullPath + "/" + filenames[i]);
            toPlay.play();

            isPaused = false;
            block = false;
            wichIsPlaying = i;
          }
        }
      }
      /*} else {
       else if (mouseX > 10 && mouseX < width / 2 && mouseY > 10 && mouseY < height / 8) {
       isCharged = false;
       selectFolder("Nouveau Dossier:", "changeFolder");
       }
       }*/
      /*} else {  //vrect(width/4, height/1.6, width/2, height/8)
       if (mouseX > width / 4 && mouseX < width / 4 + width / 2 && mouseY > height / 1.6 && mouseY < height / 1.6 + height / 8) {
       selectFolder("Choisissez un dossier pour charger les musiques:", "folderInit");
       }*/
    }
  }

  if (inSettsMenu) {
    if (mouseX < width - 10 && mouseX > width - 50 && mouseY > 10 && mouseY < 50) {
      inSettsMenu = false;
    } else if (mouseX < 20 + 100 && mouseX > 20 ) {
      println(mouseY < 20 + 200 && mouseY > 200);
      if (mouseY < 20 + 100 && mouseY > 20) {
        settingsFile.changeDarkMode();
      } else if (mouseY < 200 + 100 && mouseY > 200) {
        refreshList();
      }
    }
  }

  if (mouseX < width && mouseX > width - 100 && mouseY > height - 100 && mouseY < height) {
    if (inSettsMenu) {
      if (pathIsExisting) {
        selectFolder("Nouveau Dossier:", "changeFolder");
      } else {
        selectFolder("Nouveau Dossier:", "folderInit");
      }
    } else {
      inSettsMenu = true;
    }
  }
}

void changeFolder(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
    //refreshList();
  } else {
    println("User selected " + selection.getAbsolutePath(), settingsFile.loadFolder() != selection.getAbsolutePath());
    if (settingsFile.loadFolder() != selection.getAbsolutePath()) {
      isCharged = false;
      settingsFile.changeFoldera(selection.getAbsolutePath());
      pathIsExisting = true;
      refreshList();
    }
  }
}

void refreshList() {
  fullPath = settingsFile.loadFolder();
  filenames = loadFilenames(fullPath);
  filenames = sort(filenames);
  nomChanson = new StringList();
  for (int i = 0; i <  filenames.length; i++) {
    toPlay = minim.loadFile(fullPath + "/" + filenames[i]);
    AudioMetaData meta;
    meta= toPlay.getMetaData();
    nomChanson.append(meta.title());
  }
  minim.stop();
  minim = new Minim(this);
  wichIsPlaying = 0;
  isCharged = true;
}

void folderInit(File selection) {
  if (selection != null) {
    settingsFile.changeFoldera(selection.getAbsolutePath());
    fullPath = selection.getAbsolutePath();
    filenames = loadFilenames(fullPath);
    filenames = sort(filenames);
    nomChanson = new StringList();
    for (int i = 0; i <  filenames.length; i++) {
      toPlay= minim.loadFile(fullPath + "/" + filenames[i]);
      AudioMetaData meta;
      meta =toPlay.getMetaData();
      nomChanson.append(meta.title());
    }
    minim = new Minim(this);
    wichIsPlaying = filenames.length - 1;
    pathIsExisting = true;
    isCharged = true;
  } else {
    isCharged = false;
    pathIsExisting = false;
  }
}

void mouseWheel(MouseEvent event) {
  if (!inSettsMenu) {
    float e = event.getCount();
    if (e == -1) {
      //println("vers le bas");
      changeOffstses(30, false);
    } else if (e == 1) {
      //println("vers le haut");
      changeOffstses( -30, false);
    }
  }
}

void keyPressed() {
  //println(key, int(keyCode));
  if (keyCode == 38) {
    changeOffstses(10, false);
  } else if (keyCode == 40) {
    changeOffstses( - 10, false);
  }
  if (key == ' ' && !inSettsMenu && filenames.length!= 0) {
    if (block) {
      block = false;
      changeMusique();
    } else {
      if (!isPaused) {
        toPlay.pause();
        isPaused = true;
      } else {
        toPlay.play();
        isPaused = false;
      }
    }
  }
}

void changeOffstses(int facteur, boolean needTheThing) {
  if (!inSettsMenu && isCharged) {
    //println(needTheThing);
    if (needTheThing) {
      offsets = 0;
      //println(offsets);
      while (!(height - 100 > ((filenames.length + 1) * 100) + 100 + offsets)) {
        offsets -= 1;
        //println((filenames.length-1) * 100 + 100 + offsets, !(height-100 > (filenames.length) * 100 + 100 + offsets));
      }
      //println(offsets);
    } else {
      offsets += facteur;
      if (offsets > 0) {
        offsets = 0;
      }
      //println(height-100 > (filenames.length-1) * 100 + 100, height-100 > (filenames.length-1) * 100 + 100 + offsets);
      /*if (height-100 > (filenames.length-1) * 100 + 100) {
       offsets = 0;
       }*/
      if (height - 101 >= ((filenames.length - 1) * 100) + 100 + offsets) {
        while ((height - 101 >= ((filenames.length - 1) * 100) + 100 + offsets)) {
          offsets++;
        }
      }
      /*if (height-100 > ((filenames.length-1) * 100)+ 100 + offsets) {
       //offsets = height / ((filenames.length-1) * 100 + 100);
       offsets = poffests;
       }*/
      //println(offsets, height/((filenames.length-3)));
    }

    //println(offsets);
  }
}

void changeMusique() {
  if (wichIsPlaying < 0) {
    wichIsPlaying = filenames.length - 1;
  } else if (wichIsPlaying > filenames.length - 1) {
    wichIsPlaying = 0;
  }

  if (toPlay.isPlaying() && filenames.length!= 0) {
    toPlay.close();
  }
  isPaused = false;
  tempsChanson = 0;
  toPlay = minim.loadFile(fullPath + "/" + filenames[wichIsPlaying]);
  toPlay.play();
}

void degradeInit() {
  coulBC1 = new int[3];
  for (int i = 0; i<coulBC1.length; i++) {
    coulBC1[i] = int(random(0, 256));
  }
  coulBC2 = new int[3];
  for (int i = 0; i < coulBC2.length; i++) {
    coulBC2[i] = int(random(coulBC1[i], 256));
  }
  coulBCInter = new int[3];
  for (int i = 0; i < coulBCInter.length; i++) {
    coulBCInter[i] = coulBC2[i] - coulBC1[i];
  }
  for (int i = 0; i < coulBC1.length; i++) {
    println(coulBC1[i], coulBC2[i], coulBCInter[i]);
  }
}

void degrade(/*int x, int y, float w, float h, color c1, color c2, int axis*/ ) { //color(12,81,255), color(1,10,22)
  //noStroke();
  beginShape();
  fill(coulBCInter[0], coulBCInter[1], coulBCInter[2]);
  vertex(0, 0);
  fill(coulBC1[0], coulBC1[1], coulBC1[2]);//fill(6, 45, 138);
  vertex(width, 0);
  fill(coulBC2[0], coulBC2[1], coulBC2[2]);//fill(1, 10, 22);
  vertex(width, height);
  fill(coulBCInter[0], coulBCInter[1], coulBCInter[2]);//fill(6, 45, 138);
  vertex(0, height);
  endShape(CLOSE);
}

String[] loadFilenames(String path) {
  File folder = new File(path);
  FilenameFilter filenameFilter = new FilenameFilter() {
    public boolean accept(File dir, String name) {
      return name.toLowerCase().endsWith(".mp3") || name.toLowerCase().endsWith(".wav") || name.toLowerCase().endsWith(".aiff") || name.toLowerCase().endsWith(".au") || name.toLowerCase().endsWith(".snd"); // change this to any extension you want
    }
  };
  return folder.list(filenameFilter);
}

public class DisposeHandler {

  DisposeHandler(PApplet pa)
  {
    pa.registerMethod("dispose", this);
  }

  public void dispose()
  {
    println("Closing sketch");
    settingsFile.writeSizeWindow();
    // Place here the code you want to execute on exit
  }
}
